/*
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//var LOGFILE_NAME = "app-nambu-meter.log";
//var l = new Logger(LOGFILE_NAME);

var l={};
l.logln=function(empty){};

function addLeadingZeroes(number, count) {
	var result = '' + number;
	while (result.length < count) {
		result = '0' + result;
	}
	return result;
}

function getRFCDate() {
	var d = new Date();
	var result = '';

	result += d.getUTCFullYear();
	result += '-' + addLeadingZeroes(d.getUTCMonth() + 1, 2);
	result += '-' + addLeadingZeroes(d.getUTCDate(), 2) + 'T';
	result += addLeadingZeroes(d.getUTCHours(), 2);
	result += ':' + addLeadingZeroes(d.getUTCMinutes(), 2);
	result += ':' + addLeadingZeroes(d.getUTCSeconds(), 2);
	result += '.000Z';
	return result;
}

function createFullPOSTString(apiKey, meterValueString) {
	var version = Property.getProperty('version');

	var result = '';
	result += 'POST /DigitalStrom/Api?version=' + version + '&apiKey=' + apiKey + ' HTTP/1.0\r\n';
	result += 'Connection: close\r\n';
	result += 'Host: meter.nambu.ch\r\n';
	//result += 'Authorization: AuthSub token="' + token + '"\r\n';
	result += 'Content-Type: application/atom+xml\r\n';

	var content = '';
	content += '<?xml version="1.0" encoding="UTF-8"?>\r\n';
	content += '<meterData xmlns="http://meter.nambu.ch/schemas/meterData" xmlns:xsi="http://www.w3.org/2000/10/XMLSchema-instance">\r\n';
	content += meterValueString;
	content += '</meterData>';

	result += 'Content-Length: ';
	result += content.length;
	result += '\r\n\r\n';
	result += content + '\r\n';

	return result;
}

function createMeterValueString(meterValue, id, timestamp) {
	var content = '';

	content += '<entry>\r\n';
	content += ' <id>' + id + '</id>\r\n';
	content += ' <timestamp>' + timestamp + '</timestamp>\r\n';
	content += ' <value>' + meterValue + '</value>\r\n';
	content += '</entry>\r\n';

	return content;
}

function sendMeterData() {
	l.logln("SendData");
	
	var apikey = Property.getProperty("apiKey");
	if  ((apikey==null) || (apikey==""))
	{
		l.logln("Keine Logindaten vorhanden");
		return;
	}
	
	l.logln("SendingData with key " + typeof(apikey));
	
	var Meters=getNeededDSMs();
	//var meterDSID=[];
	var minResolution=60;
	//var oSeries=Metering.getResolutions();
	/*for (var index in oSeries)
	{
		var object=oSeries[index];
		//l.logln("objecttype: "+object.type);
		if (object.type=="consumption") 
			if (minResolution==-1)
				minResolution=object.resolution;
			else 
				if (minResolution>object.resolution)
					minResolution=object.resolution;
		
	}
	
	if (minResolution==-1)
		l.logln("Konnte kleinste Aufloesung nicht bestimmen");
	*/
	l.logln("min resolution: "+minResolution);
	
	var postString="";
	var iMeterCounter=0;
	var iValueCounter=0;
	var timestamp = getRFCDate();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		
		var value = Apartment.getDSMeterByDSID(oMeter.dsid).getPowerConsumption();
		postString += createMeterValueString(value, oMeter.dsid, timestamp);
		
		/*var presentString="/apartment/dSMeters/" + oMeter.dsid +"/present";
		if (Property.getProperty(presentString)) 
		{
			l.logln("Check "+oMeter.dsid);
			var oValues=Metering.getValues(oMeter.dsid,"consumption",minResolution);
			iMeterCounter++;
			for (var mIndex=0;(mIndex<oValues.length)&&(mIndex<5);mIndex++) {
				var sValue=oValues[mIndex];
				if (sValue!=null) {
					iValueCounter++;
					
					l.logln("Wert: " + sValue.timestamp + " " + sValue.value);

					postString += createMeterValueString(sValue.value, oMeter.dsid, sValue.timestamp);
				}
			}
		}*/
	}
	var sString="nambu-meter -> Sende " + iValueCounter + " von " + iMeterCounter + " dSMs";
	
	var req = createFullPOSTString(apikey, postString);

	l.logln(req);
	var socket = new TcpSocket();
	function onConnect(state, reqString) {
		if (state) {
			socket.send(reqString, function(bytesSent) {
				socket.receiveLine(128,
						function(data) {
							if (data != "HTTP/1.1 200 OK") {
								l.logln(sString + " NICHT ERFOLGREICH! Server Error. Received data: "
										+ data);
								print(sString + " NICHT ERFOLGREICH! Server Error. Received data: "
										+ data);
							} else {
								l.logln(sString + " erfolgreich");
								print(sString + " erfolgreich");
							}
							socket.close();
						});
			});
		} else {
			l.logln("Connection failed");
		}
	}

	socket.connect('meter.nambu.ch', 80, function(state) {
		onConnect(state, req);
	});
}

function getNeededDSMs()
{
	var oReturnMeters=[];
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		l.logln("Check "+oMeter.dsid);
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")!=null)
		{
			if (Property.getProperty("dSM/" + oMeter.dsid + "/enabled")) {
				oReturnMeters.push(oMeter);
				l.logln("Accept "+oMeter.dsid);
			}
		} else {
			oReturnMeters.push(oMeter);
			l.logln("Not specified, so accept "+oMeter.dsid);
		}
	}
	return oReturnMeters;
}

function prepare()
{
	l.logln("prepare api key: " + raisedEvent.parameter.apikey);
	if (raisedEvent.parameter.apikey==null)
		return;
	var prop = new Property('apiKey');
	prop.setValue(raisedEvent.parameter.apikey);
	prop.setFlag('ARCHIVE', true);
	
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")==null)
		{
			var prop = new Property("dSM/" + oMeter.dsid + "/dSID");
			prop.setValue(oMeter.dsid);
			prop.setFlag('ARCHIVE', true);
			prop = new Property("dSM/" + oMeter.dsid + "/enabled");
			prop.setValue(true);
			prop.setFlag('ARCHIVE', true);
		}
	}
	
	Property.store();
	sendMeterData();
}

function main() {
	l.logln("raised event "+raisedEvent.name);
	if (raisedEvent.name === "running") {
		Property.load();
	}
	else if (raisedEvent.name === "nambu-meter") {
		l.logln("raised action "+raisedEvent.parameter.actions);
		if (raisedEvent.parameter.actions) {
			l.logln('Execute: ' + raisedEvent.name + ' '+raisedEvent.parameter.actions);
			if (raisedEvent.parameter.actions == 'load')
				Property.load();
			if (raisedEvent.parameter.actions == 'save')
				Property.store();
			if (raisedEvent.parameter.actions == 'sendMeterData')
				sendMeterData();
			if (raisedEvent.parameter.actions == 'prepare')
				prepare();
		}

	}

}

main();